<!---
<fusedoc fuse="FusedocMiner.cfm" language="ColdFusion" version="2.0">
  <responsibilites>
    I read a Fusebox 4 application's fuse files, starting at the current directory,
    and produce an XSLT transformation from the specified stylesheet.
  </responsibilities>
  <properties>
    <history date="21 Feb 2006" author="Jeff Peters" email="jeff@grokfusebox.com" type="create">Version 1.0</history>
    <history date="11 Apr 2007" author="Jeff Peters" email="jeff@grokfusebox.com" type="create">Version 1.1</history>
  </properties>
  <io>
    <in>
      <string name="thisDir" scope="attributes" optional="true" default="current path" />
      <boolean name="recurse" scope="attributes" optional="true" default="yes" />
      <string name="xslFile" optional="true" default="FusedocMiner.xsl" />
    </in>
    <out>
    </out>
  </io>
</fusedoc>
--->
<cfparam name="attributes.thisDir" default="#GetDirectoryFromPath(GetCurrentTemplatePath())#">
<cfparam name="attributes.recurse" default="yes">
<cfparam name="attributes.xslFile" default="#attributes.thisDir#\FusedocMiner.xsl">
<cfparam name="attributes.fusePrefixes" default="dsp,act,qry">
<cfparam name="attributes.outputFile" default="#attributes.thisDir#FusedocMinerOutput.html">

<!--- Read directory entries into array --->
<cfdirectory name="qryThisDir"
           action="LIST"
        directory="#attributes.thisDir#">
        
<!--- For each entry in files array: --->
<cfloop query="qryThisDir">
  <!--- Select based on entry type: --->
  <cfswitch expression="#Trim(qryThisDir.type)#">
    <cfcase value="File">
      <!--- If it's a fuse file, transform it and write it to the output file --->
      
      <cfif ListFindNoCase(attributes.fusePrefixes,Left(qryThisDir.Name,3))>
        <cfset dirName = ListLast(attributes.thisDir,"\")>
        <cffile action="read" 
		          file="#attributes.thisDir#\#qryThisDir.Name#" 
		      variable="fuseFile">
				<!--- Strip out the Fusedoc --->
				<cfset inFusedoc = false>
				<cfset fusedocText = "">
				<cfloop from="1" to="#ListLen(fuseFile,Chr(10))#" index="i">
					<cfif FindNoCase("<fusedoc",ListGetAt(fuseFile,i,Chr(10)))>
						<cfset inFusedoc = true>
					</cfif>
					<cfif inFusedoc>
						<cfset fusedocText = fusedocText & ListGetAt(fuseFile,i,Chr(10))>
					</cfif>
					<cfif FindNoCase("</fusedoc",ListGetAt(fuseFile,i,Chr(10)))>
						<cfset inFusedoc = false>
					</cfif>
				</cfloop>		      
		    <cffile action="read"
				          file="#attributes.xslFile#" 
				      variable="xslCode">

				<!---
          <cfset newHTML = XMLTransform(fusedocText, xslCode)>
        --->

				<cftry>
          <cfset newHTML = XMLTransform(fusedocText, xslCode)>
  				<cffile action="append"   
  					        file="#attributes.outputFile#" 
  						    output="#newHTML#" 
  				    addnewline="true">
          <cfcatch type="Any">
            <cfoutput><li><b>Error in #qryThisDir.Name#:</b>#cfcatch.message# - #cfcatch.detail#<br /></li></cfoutput>
            <cfflush>
          </cfcatch>
        </cftry>
      </cfif>
    </cfcase>
    
    <cfcase value="Dir">
      </ol>
      <h4>Reading <cfoutput>#qryThisDir.Name#</cfoutput></h4>
      <ol>
      <!--- Prevent recursion of the entire hard drive --->
      <cfif not ListFind(".,..",qryThisDir.Name) AND attributes.recurse>
        <!--- If directory entry, recurse with main   --->
        <cf_FusedocMiner thisDir="#attributes.thisDir#\#qryThisDir.Name#"
                         recurse="#attributes.recurse#"
                         xslFile="#attributes.xslFile#"
                    fusePrefixes="#attributes.fusePrefixes#"
                      outputFile="#attributes.outputFile#">
      </cfif>
    </cfcase>
    <cfdefaultcase>
      No handler for #qryThisDir.type#.
    </cfdefaultcase>
  </cfswitch>
</cfloop>
